
SuperStrict

Framework brl.Max2d
Import brl.Graphics
Import brl.pngloader
Import brl.polledinput
Import brl.standardIO
Import BRL.GLMax2D
Import BRL.Random
SeedRnd MilliSecs()
Global game:Byte

Type TUnit
	Global List:TList = CreateList(),player:TUnit
	
	Field npc:Byte,team:Byte,x:Float,y:Float,hp:Float,maxhp:Int,gfx:TImage,dir:Int,anim:Float
	Field name:String,dmg:Float,cast:Float,mblood:Byte
	
	Function NearestEnemy:TUnit(team:Int,x:Int,y:Int)
		Local d:Int=1000
		Local o:TUnit
		For Local uTmp:TUnit=EachIn List
			Local cd:Int=((uTmp.x-x)^2+(uTmp.y-y)^2)^.5
			If cd<d And uTmp.team<>team Then d=cd;o=UTmp
		Next
		Return o
	End Function
	
	Function updateall()
		For Local uTmp:TUnit = EachIn List
			uTmp.draw()
			uTmp.update()
		Next
	End Function
	
	Method doCast:Int(cd:Int,pt:Int,h:Int=1)
		If h=1 Then If KeyHit(cd)=0 Then Return 0
		If h=0 Then If KeyDown(cd)=0 Then Return 0
		If cast<pt Then Return 0
		cast:-pt
		Return 1
	End Method
	
	Method update()
		If hp<=0 Then
			ListRemove(list,Self)
			gfx=Null
			If mblood Then TBlood.Create(x,y)
			If Self=player Then game=0
			Return
		ElseIf hp>maxhp
			hp=maxhp
		EndIf
		If npc Then
			Local e:TUnit=NearestEnemy(team,x,y)
			Local d:Int=ATan2(e.x-x,e.y-y)
			If e<>Null Then
				If ((e.x-x)^2+(e.y-y)^2)^.5<15 Then
					e.hp:-dmg
				Else
					x:+Sin(d)
					y:+Cos(d)
				EndIf
			EndIf
		Else
			Local s:Float
			If MouseDown(2) Then
				cast:+1
				If doCast(49,40) Then TSpell.Create(x,y,"gfx\iceball",..
										ATan2(MouseX()-x,MouseY()-y),3,200,50)
				If doCast(50,3,0) Then TSpell.Create(x,y,"gfx\fire",..
										ATan2(MouseX()-x,MouseY()-y)+Rand(-10,10),3,100,6)
				If doCast(51,250) Then hp:+100;TSplash.Create(x,y,"explo",100,0,50,60,.16,10)
				If doCast(52,130) Then
					Local nb:TBlood=TBlood.GetNearest(MouseX(),MouseY())
					If nb Then
						TSplash.Create(nb.x,nb.y,"explo",70,0,50,60,.16,10)
						ListRemove(TBlood.list,nb)
					EndIf
				EndIf
				If doCast(53,100) Then
					Local h:TUnit=NearestEnemy(1-team,MouseX(),MouseY())
					h.hp:+40
					TSplash.Create(h.x,h.y,"heal",0,0,0,60,.16,10)
				EndIf
				If doCast(54,250) Then
					Local nb:TBlood=TBlood.GetNearest(MouseX(),MouseY())
					If nb Then
						TSplash.Create(nb.x,nb.y,"summon",0,0,0,100,.16,16,1)
						ListRemove(TBlood.list,nb)
					Else
						cast:+100
					EndIf
				EndIf
				If cast>255 Then cast=255
				s=.4
			Else
				cast:-.1
				s=1
			EndIf
			If KeyDown(68) Then dir=1;x:+s;anim:+.2
			If KeyDown(65) Then dir=3;x:-s;anim:+.2
			If KeyDown(87) Then dir=0;y:-s;anim:+.2
			If KeyDown(83) Then dir=2;y:+s;anim:+.2
			If x<50 Then x=50
			If x>750 Then x=750
			If y<100 Then y=100
			If y>550 Then y=550
		EndIf
		anim:Mod 3
	End Method
	
	Method draw()
		SetColor(255-cast,255-cast,255)
		DrawImage(gfx,x,y,dir*3+Int(anim))
		SetColor(200,0,0)
		DrawText(name,x-Len(name)*4,y-30)
		SetColor(64,64,64)
		DrawRect(x-15,y-17,30,5)
		SetColor(200,0,0)
		DrawRect(x-14,y-16,(hp*28)/maxhp,3)
		SetColor(255,255,255)
	End Method
	
	Method init(pnpc:Byte,pteam:Byte,px:Int,py:Int,php:Int,pgfx:String,pname:String,..
						pdmg:Float,pmblood:Byte)
		npc=pnpc
		If pnpc=0 Then player=Self
		team=pteam
		x=px
		y=py
		hp=php
		maxhp=php
		name=pname
		dmg=pdmg
		mblood=pmblood
		gfx=LoadAnimImage(pgfx+".png", 24, 32, 0, 12, MASKEDIMAGE)
		MidHandleImage(gfx)
	End Method
	
	Function Create:TUnit(pnpc:Byte,pteam:Byte,px:Int,py:Int,php:Int,pgfx:String,pname:String,..
						pdmg:Float,pmblood:Byte=1)
		Local uTmp:TUnit=New TUnit
		ListAddLast(List,uTmp)
		uTmp.init(pnpc,pteam,px,py,php,pgfx,pname,pdmg,pmblood)
		Return uTmp
	End Function
End Type

Type TSplash
	Global List:TList=CreateList()
	Field x:Float,y:Float,gfx:TImage,dot:Float,rad:Int,time:Int,a:Float,aspeed:Float,maxa:Int,s:Byte
	
	Method init(px:Int,py:Int,pgfx:String,pdmg:Int,pdot:Float,prad:Int,ptime:Int,..
					panimspeed:Float,pmaxanim:Int,ps:Byte)
		gfx=LoadAnimImage("gfx\"+pgfx+".png", 96, 96, 0, pmaxanim)
		MidHandleImage(gfx)
		maxa=pmaxanim
		x=px
		y=py
		dot=pdot
		time=ptime
		aspeed=panimspeed
		rad=prad
		s=ps
		For Local uTmp:TUnit=EachIn TUnit.list
			If ((x-uTmp.x)^2+(y-uTmp.y)^2)^.5<rad Then uTmp.hp:-pdmg
		Next
		ListAddLast(list,Self)
	End Method
	
	Method update()
		SetColor(255,255,255)
		DrawImage(gfx,x,y,Int(a))
		For Local uTmp:TUnit=EachIn TUnit.list
			If ((x-uTmp.x)^2+(y-uTmp.y)^2)^.5<rad Then uTmp.hp:-dot
		Next
		time:-1
		a:+aspeed
		a:Mod maxa
		If time<=0 Then
			If s=1 Then TUnit.Create(1,0,x,y,130,"GFX\skeletton","Skeletton",.15,0)
			ListRemove(list,Self)
		EndIf
	End Method
	
	Function updateall()
		For Local spTmp:TSplash=EachIn list
			spTmp.update()
		Next
	End Function
	
	Function Create(px:Int,py:Int,pgfx:String,pdmg:Int,pdot:Float,prad:Int,ptime:Int,..
					panimspeed:Float,pmaxanim:Int,ps:Byte=0)
		Local spTmp:TSplash=New TSplash
		spTmp.init(px,py,pgfx,pdmg,pdot,prad,ptime,panimspeed,pmaxanim,ps)
	End Function
End Type

Type TSpell
	Global List:TList = CreateList()
	Field x:Float,y:Float,gfx:TImage,dir:Int,speed:Int,range:Int,dmg:Int
	
	Function update()
		For Local spTmp:TSpell=EachIn list
			SetRotation(-spTmp.dir+90)
			DrawImage(spTmp.gfx,spTmp.x,spTmp.y)
			spTmp.x:+Sin(spTmp.dir)*spTmp.speed
			spTmp.y:+Cos(spTmp.dir)*spTmp.speed
			spTmp.range:-spTmp.speed
			If spTmp.range<0 Then spTmp.gfx=Null;ListRemove(List,spTmp);Continue
			For Local uTmp:TUnit = EachIn TUnit.list
				If Abs(spTmp.x-uTmp.x)<10 And Abs(spTmp.y-uTmp.y)<15 Then
					uTmp.hp:-spTmp.dmg
					spTmp.gfx=Null;ListRemove(List,spTmp);spTmp=Null
				EndIf
			Next
		Next
		SetRotation(0)
	End Function
	
	Method init(px:Int,py:Int,pgfx:String,pd:Int,ps:Int,pr:Int,pdmg:Int)
		px:+Sin(pd)*20
		py:+Cos(pd)*20
		x=px
		y=py
		gfx=LoadImage(pgfx+".png")
		MidHandleImage(gfx)
		dir=pd
		speed=ps
		range=pr
		dmg=pdmg
	End Method
	
	Function Create:TSpell(px:Int,py:Int,pgfx:String,pd:Int,ps:Int,pr:Int,pdmg:Int)
		Local spTmp:TSpell=New TSpell
		spTmp.init(px,py,pgfx,pd,ps,pr,pdmg)
		ListAddLast(List,spTmp)
		Return spTmp
	End Function
End Type

Type TBlood
	Global gfx:TImage = LoadImage("gfx\blood.png"),list:TList=CreateList()
	Field x:Int,y:Int
	Function GetNearest:TBlood(px:Int,py:Int)
		Local d:Int=1000
		Local o:TBlood
		For Local blTmp:TBlood=EachIn list
			Local cd:Int = ((px-blTmp.x)^2+(py-blTmp.y)^2)^.5
			If cd<d Then d=cd;o=blTmp
		Next
		Return o
	End Function
	Function draw()
		SetColor(255,255,255)
		For Local blTmp:TBlood=EachIn list
			DrawImage(blTmp.gfx,blTmp.x,blTmp.y)
		Next
	End Function
	Function Create(px:Int,py:Int)
		MidHandleImage(gfx)
		Local blTmp:TBlood=New TBlood
		ListAddLast(list,blTmp)
		blTmp.x=px
		blTmp.y=py
	End Function
End Type

Type GameState Abstract
	Global gfx:TImage[5]
	Global wave:Int, wavetimer:Int, wavedata:Float[][], wavestr:String[][], wavemax:Int
	
	Function Load()
		For Local i:Int=0 To 4
			gfx[i]=LoadImage("gfx\"+i+".png")
		Next
		wavetimer=5000+MilliSecs()
		Local z:String="Zombie"
		Local t:String="Troll"
		Local d:String="Daemon"
		makewave(1,80,.12,"gfx\"+z,z,10)
		makewave(2,80,.12,"gfx\"+z,z,10)
		makewave(3,80,.12,"gfx\"+z,z,10)
		makewave(4,80,.12,"gfx\"+z,z,10)
		makewave(6,80,.12,"gfx\"+z,z,10)
		makewave(4,120,.18,"gfx\"+t,t,15)
		makewave(8,80,.12,"gfx\"+z,z,12)
		makewave(2,180,.25,"gfx\"+d,d,15)
		makewave(6,120,.18,"gfx\"+t,t,15)
		makewave(10,80,.12,"gfx\"+z,z,12)
		makewave(8,120,.18,"gfx\"+t,t,15)
		makewave(5,180,.25,"gfx\"+d,d,15)
		makewave(10,120,.18,"gfx\"+t,t,15)
		makewave(14,120,.18,"gfx\"+t,t,15)
		makewave(16,120,.18,"gfx\"+t,t,15)
		makewave(10,180,.25,"gfx\"+d,d,15)
		makewave(16,180,.25,"gfx\"+d,d,15)
		makewave(20,180,.25,"gfx\"+d,d,15)
		makewave(25,180,.25,"gfx\"+d,d,15)
		makewave(30,180,.25,"gfx\"+d,d,15)
		makewave(35,180,.25,"gfx\"+d,d,15)
		makewave(45,180,.25,"gfx\"+d,d,15)
		makewave(60,180,.25,"gfx\"+d,d,15)
	End Function
	
	Function nextwave()
		If wave>=wavemax Then
			Local f:Float
			Local r:Int
			While f>.00001
				game=0
			Wend
			End
		EndIf
		For Local i:Int=1 To wavedata[wave][0]
			TUnit.Create(1,1,Rand(50,750),Rand(100,550),wavedata[wave][1],wavestr[wave][0],..
						wavestr[wave][1],wavedata[wave][2])
		Next
		wavetimer=MilliSecs()+wavedata[wave][3]
		wave:+1
	End Function
	
	Function makewave(ct:Int,hp:Int,dmg:Float,gfx:String,name:String, time:Int)
		wavemax:+1
		wavedata = wavedata[..wavemax]
		For Local i:Int=0 To wavemax-1
			wavedata[i] = wavedata[i][..4]
		Next
		wavestr = wavestr[..wavemax]
		For Local i:Int=0 To wavemax-1
			wavestr[i] = wavestr[i][..3]
		Next
		wavedata[wavemax-1][0]=ct
		wavedata[wavemax-1][1]=hp
		wavedata[wavemax-1][2]=dmg
		wavedata[wavemax-1][3]=time*1000
		wavestr[wavemax-1][0]=gfx
		wavestr[wavemax-1][1]=name
	End Function
	
	Function update()
		draw()
		If wavetimer<MilliSecs() Then nextwave()
		TBlood.draw()
		TUnit.updateall()
		TSpell.update()
		TSplash.updateall()
	End Function
	
	Function draw()
		Local cast:Int = TUnit.player.cast/4
		SetColor(128-cast,128-cast,128)
		For Local x:Int=32 To 768 Step 32
			For Local y:Int=96 To 568 Step 32
				DrawImage(gfx[4],x,y)
			Next
		Next
		For Local y:Int=0 To 568 Step 32
			DrawImage(gfx[0],0,y)
		Next
		For Local x:Int=32 To 736 Step 64
			DrawImage(gfx[1],x,0)
		Next
		For Local y:Int=0 To 568 Step 32
			DrawImage(gfx[0],768,y)
		Next
		For Local x:Int=0 To 768 Step 32
			DrawImage(gfx[0],x,568)
		Next
		SetColor 200,0,0
		DrawText "Wave: "+wave,380,10
	End Function

	Function menu()
		ClearList(TSplash.list)
		ClearList(TSpell.list)
		ClearList(TBlood.list)
		While KeyHit(32)=0
			draw()
			SetColor 255,0,0
			SetScale 4,4
			DrawText "Magic Gladiator",160,100
			SetScale 1.2,1.2
			DrawText "... auch Magier brauchen Brot und Spiele.",170,155
			SetScale 1,1
			DrawText "by DAK",730,20
			DrawText "Druecke die Leertaste!",328,450
			Flip
		Wend
		FlushKeys
	End Function
End Type

SetGraphicsDriver GLMax2DDriver()
Graphics(800, 600, 0)

GameState.Load()
While 1
	ClearList(TUnit.list)
	GameState.wave=0
	TUnit.Create(0,0,400,300,100,"gfx\player","Player",0)
	TUnit.Create(1,0,460,300,100,"gfx\skeletton","Skeletton",.1)
	GameState.menu()
	
	game=1
	
	While game
		If KeyHit(27) End
		Cls
		GameState.update()
		Flip
	Wend
Wend