SuperStrict

Framework brl.standardio
Import brl.linkedlist
Import BRL.FileSystem
Import BRL.Retro

Type TToken
	Global list:TList = CreateList()
	Field orig:String, repl:String, block:String
	Function Create(o:String,r:String,b:String)
		If Check(o,r)=0 Then Return
		Local tTemp:TToken = New TToken
		tTemp.orig=o
		tTemp.repl=r
		'tTemp.block=b
		ListAddLast(list,tTemp)
	End Function
	Function Check:Byte(sName:String, sRepl:String)
		For Local tTemp:TToken = EachIn list
			If tTemp.orig=sName And Left(sRepl,1)=Left(tTemp.repl,1) Then Return 0
		Next
		Return 1
	End Function
EndType

Type Code Abstract
	Global lines:String[]
	Global tnumber:Int[]
	
	Function gettokens()
		Local block:String
		For Local i:Int = 0 To lines.length-1
			Local w:String=Replace(lines[i],";","")
			If Left(w,5)="Type " Then block:+"."+Mid(w,6,Instr(w," ",6)-6)
			If Left(w,9)="Function " block:+"."+Mid(w,6,Instr(w," ",10)-10)
			If Left(w,7)="Method " Then block:+"."+Mid(w,6,Instr(w," ",7)-7)
			If Left(w,7)="EndType" Then block=unblock(block)
			If Left(w,8)="End Type" Then block=unblock(block)
			If Left(w,11)="EndFunction" Then block=unblock(block)
			If Left(w,12)="End Function" Then block=unblock(block)
			If Left(w,9)="EndMethod" Then block=unblock(block)
			If Left(w,10)="End Method" Then block=unblock(block)
			If Left(w,6)="Local " Then getalltokens(Mid(w,7),0,block)
			If Left(w,7)="Global " Then getalltokens(Mid(w,8),1,block)
			If Left(w,6)="Field " Then getalltokens(Mid(w,7),2,block)
			If Left(w,9)="Function " Then getalltokens(Mid(w,10),3,block)
			If Left(w,5)="Type " Then getalltokens(Mid(w,6),4,block)
		Next
	End Function
	
	Function getalltokens(ln:String,typ:Int,block:String)
		ln=","+ln
		ln=Replace(ln," ","")
		Local repl:String
		If typ=0 Then repl="l"
		If typ=1 Then repl="g"
		If typ=2 Then repl="f"
		If typ=3 Then repl="u"
		If typ=4 Then repl="t"
		Local pos:Int=1
		Local pos2:Int
		While pos>0
			pos2 = Instr(ln,":",pos+1)
			
			Local iTempPos:Int = Instr(ln," ",pos+1)-1
			If pos2>iTempPos And iTempPos>0 Then pos2=iTempPos
			
			iTempPos = Instr(ln,"(",pos+1)-1
			If pos2>iTempPos And iTempPos>0 Then pos2=iTempPos
			
			If pos2=0 Then pos2=iTempPos
			Local c:Int=0
			For Local i:Int=1 To pos
				If Mid(ln,i,1)="(" Then c:+1
				If Mid(ln,i,1)=")" Then c:-1
			Next
			If c=0 Then
				Local orig:String=Mid(ln,pos+1,pos2-pos-1)
				If Len(orig)>3 Then
					TToken.Create(orig,repl+tnumber[typ],block)
					If typ=3 Then DebugLog("fnd")
					tnumber[typ]:+1
				EndIf
			EndIf
			pos = Instr(ln,",",pos+1)
		Wend
	End Function
	
	Function replacetokens()
		Local block:String
		For Local i:Int = 0 To lines.length-1
			Print i
			If Left(lines[i],5)="Type " Then block:+"."+Mid(lines[i],6,Instr(lines[i]," ",6)-6)
			If Left(lines[i],9)="Function " block:+"."+Mid(lines[i],6,Instr(lines[i]," ",10)-10)
			If Left(lines[i],7)="Method " Then block:+"."+Mid(lines[i],6,Instr(lines[i]," ",7)-7)
			If Left(lines[i],7)="EndType" Then block=unblock(block)
			If Left(lines[i],8)="End Type" Then block=unblock(block)
			If Left(lines[i],11)="EndFunction" Then block=unblock(block)
			If Left(lines[i],12)="End Function" Then block=unblock(block)
			If Left(lines[i],9)="EndMethod" Then block=unblock(block)
			If Left(lines[i],10)="End Method" Then block=unblock(block)
			For Local tTemp:TToken = EachIn TToken.list
				If Instr(block,tTemp.block) Then lines[i]=ok(lines[i],tTemp.orig,tTemp.repl);Continue
				If Left(tTemp.orig,1)="g" Then lines[i]=ok(lines[i],Mid(block,2)+tTemp.orig,..
															Mid(block,2)+tTemp.repl)
			Next
		Next
	End Function
	
	Function unblock:String(block:String)
		Local blocknr:Int
		Local pos:Int=Instr(block,".")
		While pos>0
			blocknr:+1
			pos=Instr(block,".",pos+1)
		Wend
		pos=0
		For Local i:Int = 0 To blocknr-1
			pos=Instr(block,".",pos+1)
		Next
		Return Left(block,pos-1)
	End Function
	
	Function ok:String(ln:String,vname:String,tok:String)
		Local pos:Int=Instr(Lower(ln),Lower(vname))
		'If Instr(ln,"ClearList") Then DebugStop()
		'If Left(ln,11)="If cd<d And" And tok="l0" Then DebugStop
		While pos>0
			Local lok:Byte=1
			Local rok:Byte=1
			If pos<>1 Then lok=testchr(Asc(Mid(ln,pos-1,1)))
			If pos+Len(vname)<>Len(ln) Then rok=testchr(Asc(Mid(ln,pos+Len(vname),1)))
			If lok=1 And rok=1 Then ln=replone(ln,vname,tok,pos)
			pos=Instr(Lower(ln),Lower(vname),pos+1)
		Wend
		Return ln
	End Function

	Function testchr:Byte(ch:Int)
		If ch=34 Then Return 0
		If ch>=65 And ch<=90 Then Return 0
		If ch>=97 And ch<=122 Then Return 0
		Return 1
	End Function

	Function replone:String(str:String,fnd:String,repl:String,pos:Int)
		pos = Instr(Lower(str),Lower(fnd),pos)
		Return Left(str,pos-1)+repl+Mid(str,pos+Len(fnd))
	End Function
	
	Function readall:Int(stream:TStream)
		tnumber = tnumber[..5]
		tnumber[0]=0
		tnumber[1]=0
		tnumber[2]=0
		tnumber[3]=0
		tnumber[4]=0
		While Not Eof(stream)
			lines = lines[..lines.length+1]
			Local w:String = Trim(ReadLine(stream))
			lines[lines.length-1]=w
			While Instr(w,";")
				Local pos:Int=Instr(w,";")
				lines[lines.length-1] = Left(w,pos-1)+";"
				lines = lines[..lines.length+1]
				lines[lines.length-1] = Mid(w,pos+1)
				w=Mid(w,pos+1)
			Wend
		Wend
		Return lines.length
	End Function
	Function writeall(stream:TStream)
		Local out:String
		For Local i:Int = 0 To lines.length-1
			If Len(lines[i])>0 Then
				out:+Replace(lines[i],"  "," ")
			EndIf
			If Right(out,1)<>";" And Right(out,2)<>".." And Len(out)>0 Then
				WriteLine stream,Replace(out,"Then ","")
				out=""
			EndIf
			If Right(out,2)=".." Then out = Trim(Left(out, Len(out)-2))
		Next
	End Function
End Type

Print "read"
Code.readall(ReadFile("bcc.bmx"))
Print "get"
Code.gettokens()
Print "replace"
Code.replacetokens()
Print "write"
Code.writeall(WriteFile("bcc-small.bmx"))
Print "done"