;********************************************************************************************
;**                                     ImgToData.bb                                       **
;**  Ein kleines Tool um ein Bild "map.png" ein zu lesen und jedes Pixel zu einem Zahlen-  **
;**  wert in einem Data-Field zu machen.                                                   **
;********************************************************************************************
; 
; Schritte:
; Bild einlesen
; Farben Zhlen
; 1 Farbe -> eine Zahl
; In Data bzw. Defdate in die datei "map.txt" schreiben
AppTitle "ImgToData - www.GreenStarEntertainment.de.tl"
Graphics(400,300,0,2)
SeedRnd MilliSecs()

Type Tcolor
	Field rgb, Nr
End Type

Local Start_Time# = MilliSecs()
Global img_source = LoadImage("map.png")
If img_source = False Then
	RuntimeError("Kein 'map.png' gefunden!")
Else
	Print("map.png geladen...")
EndIf
Local hoch = ImageHeight(img_source) - 1
Local breit = ImageWidth(img_source) - 1
Dim map.Tcolor(breit, hoch)
Print("Lese Bild ("+(breit+1)+"x"+(hoch+1)+") ein")

Local x, y, rgb

SetBuffer ImageBuffer(img_source)
LockBuffer ImageBuffer(img_source)
For y = 0 To hoch
	For x = 0 To breit
		rgb = ReadPixelFast(x,y)
		map(x, y) = Color_Create(rgb)
	Next
Next
UnlockBuffer ImageBuffer(img_source)
SetBuffer BackBuffer(): Print: Print
Count_Color()

Print("Schreibe 'map.txt'")
Local out_str$ = ""
Local out_file = WriteFile("map.txt")
WriteLine out_file, "[BlitzMax]"
WriteLine out_file, "DefData "+(breit+1)+","+(hoch+1)
For y = 0 To hoch
	out_str$ = ""
	For x = 0 To breit
		out_str$ = out_str$ + map(x, y)\Nr +","
	Next
	out_str$ = "DefData " + Left(out_str$, Len(out_str$)-1)
	WriteLine out_file, out_str$
Next

WriteLine out_file, ""
WriteLine out_file, "[BlitzBasic]"
WriteLine out_file, "Data "+(breit+1)+","+(hoch+1)
For y = 0 To hoch
	out_str$ = ""
	For x = 0 To breit
		out_str$ = out_str$ + map(x, y)\Nr +","
	Next
	out_str$ = "Data " + Left(out_str$, Len(out_str$)-1)
	WriteLine out_file, out_str$
Next
CloseFile out_file

Print("Alle Aktionen dauerten "+(MilliSecs()-Start_Time#)+" ms")
Print("DONE")
WaitKey()
End

Function Color_Create.Tcolor(f_rgb)
	Local c.Tcolor
	For c = Each Tcolor
		If c\rgb = f_rgb Then Return c
	Next
	c = New Tcolor
	c\rgb = f_rgb
	Return c
End Function

Function Count_Color()
	Local c.Tcolor, i=0
	For c = Each Tcolor
		c\Nr = i
		i=i+1
	Next
	Print("Zhle "+i+" Farben")
End Function

;~IDEal Editor Parameters:
;~C#Blitz3D